=== debian/changelog ===
faust (2.75.7+ds-3+rpi1) trixie-staging; urgency=medium

  * Skip dh_dwz on armhf too.

 -- Peter Michael Green <plugwash@raspbian.org>  Sun, 29 Dec 2024 18:26:34 +0000

faust (2.75.7+ds-3) unstable; urgency=medium

  * Do not attempt to run dh_dwz on i386 and armel
    (See: #1016936, #1016563)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 12 Nov 2024 08:46:56 +0100

faust (2.75.7+ds-2) unstable; urgency=medium

  * Refresh patches with 'gbp pq'
  * Backport upstream fix for building with LLVM-19 (Closes: #1084254)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 11 Oct 2024 10:37:26 +0200

faust (2.75.7+ds-1) unstable; urgency=medium

  * New upstream version 2.75.7+ds
    + Update patches
    + Drop patches applied upstream
  * B-D on libzstd-dev
  * Strip libPolly from llvm-static-libs (Closes: #1051880)
  * Do not attempt to install faust2wasm binaries (removed upstream)
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 27 Sep 2024 22:04:59 +0200

faust (2.74.6+ds-1) unstable; urgency=medium

  * New upstream version 2.74.6+ds
    + Drop obsolete documentation patch
    + Refresh patches
    + Update patches
    + Update privacy patch
  * Install faust2stratus (Chaos Audio Stratus pedal)
  * Fix more spelling errors
  * Backport long-options fix for manpage
  * Add repository to upstream-metadata
  * Update copyright information
    + Update copyright
    + Fix dual-license for faust2ck
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 02 Sep 2024 15:46:01 +0200
